/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ImagemDAO;
import com.rjconsultores.ventaboletos.entidad.Imagem;

@Repository("imagemDAO")
public class ImagemHibernateDAO extends GenericHibernateDAO<Imagem, Integer>
		implements ImagemDAO {

	@Autowired
	public ImagemHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<Imagem> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("imagemId"));

		return c.list();
	}

	public Imagem buscarPorNomeImagem(String nomeImagem) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.eq("nombImagem", nomeImagem));

		return (Imagem) c.uniqueResult();
	}

	public List<Imagem> buscar(String nomeImagem) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.eq("nombImagem", nomeImagem));

		return c.list();
	}
}
